<?php
/**
 * 
 * @copyright Copyright(c) 2005 Daniele Ugoletti. All rights reserved.
 * @license http://www.gnu.org/copyleft/lesser.html GNU LESSER GENERAL PUBLIC LICENSE
 *
 * GLIZY is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 *
 * @author		Daniele Ugoletti <daniele@ugoletti.com>
 * @version		
 * @package		Glizy core
 * @category	
 */
 
core_import('org.glizy.dataAccess.*');

class org_glizy_dataAccess_relationHasOne extends org_glizy_dataAccess_relation
{	

	
	function  org_glizy_dataAccess_relationHasOne(&$parent, $options)
	{
		parent::org_glizy_dataAccess_relation($parent, $options);
		assert(isset($options['field']));
		$this->_key = $options['field'];
		$this->_destinationKey = isset($options['destinationField']) ? $options['destinationField'] : NULL;
	}
	
	function build($params=array())
	{
		$this->record = & org_glizy_dataAccess_DataAccess::getObject($this->_className);
		$this->record->setProcessRelations(false);
		$this->_getDestinationField();
		$this->record->{$this->_destinationKey} = $this->_parent->{$this->_key};
		
		if (count($params))
		{
			$this->record->loadFromArray($params);
		}
		$this->record->find();
		$this->_current();
	}
	
	function create($params)
	{
		$this->_reset();
		$this->record = & org_glizy_dataAccess_DataAccess::getObject($this->_className);
		$this->record->setProcessRelations(false);
		$this->_getDestinationField();

		if (count($params))
		{
			$this->record->loadFromArray($params);
		}
		
		$this->_bindRecordFields();
	}

	function bind(&$object)
	{
		if (get_class($object)!=$this->_className)
		{
			// TODO
			// visualizzare errore
		}
		
		$this->_reset();
		$this->record = &$object;
		$this->record->setProcessRelations(false);
		$this->_getDestinationField();
		$this->_bindRecordFields();
	}

	function preSave()
	{	
		$canSave = false;
		
		$currentValues = $this->record->getValuesAsArray();
		foreach ($currentValues as $k=>$v)
		{
			if (!array_key_exists($k, $this->_backUpValues) || $this->_backUpValues[$k]!=$v)
			{
				$canSave = true;
				break;
			}
		}
		if ($canSave) 
		{
			$this->record->save();
			$this->_backUpValues = $this->record->getValuesAsArray();
			$this->_parent->{$this->_key} = $this->record->{$this->_destinationKey};
		}
	}

	function _getDestinationField()
	{
		if (is_null($this->_destinationKey))
		{
			$this->_destinationKey = $this->record->getPrimaryKey();
			assert(!is_null($this->_destinationKey));
		}
	}

	function _current()
	{
		$this->_backUpValues = $this->record->getValuesAsArray();
		$this->_bindRecordFields();
	}
	
	function _reset()
	{
		$this->_backUpValues	= array();	
	}
}
?>
